<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="typeFlag" label="类型">
                <el-input v-model="formData.typeFlag" :disabled="'typeFlag'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="url" label="文件">
                <el-upload class="upload-demo" :action="$baseUrl+'/assets/uploadFile'" :on-success='haleSuccess' :before-upload='beforeUpload' :multiple="false" :file-list="fileList">
                    <el-button size="small" type="primary" :disabled="'url'==subColumn">点击上传</el-button>
                    <div slot="tip" class="el-upload__tip">只能上传单个文件 ，且不超过500kb</div>
                </el-upload>
            </el-form-item>
            <el-form-item prop="url" label="URL">
                <el-input v-model="formData.url" :disabled="'url'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="fileName" label="文件名">
                <el-input v-model="formData.fileName" :disabled="'fileName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="fileSize" label="大小（KB）">
                <el-input v-model="formData.fileSize" :disabled="'fileSize'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark" :disabled="'remark'==subColumn"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/userFileInfo/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }

                    var jsonp = {
                        name: res.data.fileName,
                        url: res.data.url
                    }
                    this.fileList.push(jsonp)

                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }

    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                typeFlag:
                    [
                        { required: true, message: '请输入 类型', trigger: 'blur' },
                    ],
            },
            subColumn: '',
            subValue: '',
            fileList: [],
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/userFileInfo/update' : '/userFileInfo/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/userFileInfo/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
        haleSuccess(file) {
            //console.log(file)
            file.data.forEach(item => {
                var nameList = item.split('/')
                var jsonp = {
                    name: nameList[nameList.length - 1],
                    url: item
                }
                this.fileList.splice(0, 1, jsonp)
                this.formData.url = item

            })
        },
        beforeUpload(file) {
            this.formData.fileName = file.name;
            this.formData.fileSize = (file.size/1024).toFixed(2);
            console.log(file)
        }
    }
}
</script>
<style lang="less" scoped>
</style>
